All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # This program is licensed under the GNU GPL version 2 or later.
4 # (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011-2013
5 # For details, see LICENSE. To submit patches, you have to agree to
6 # license your code under the GNU GPL version 2 or later.
8 # While the following is not legally binding, the author would like to
9 # explain the choice of GPLv2+ over GPLv3+.
10 # The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
11 # full compatibility's with git. In case git ever changes its licensing terms,
12 # which is admittedly extremely unlikely to the point of being impossible,
13 # this software will most likely follow suit.
15 # This should always be the first line of code to facilitate debugging
16 [ -n "$VCSH_DEBUG" ] && set -vx
19 # Implemented in shell to avoid spawning another process
22 [ -z "$2" ] || file="${file%$2}"
30 echo "$SELF: fatal: $1" >&2
34 # We need to run getops as soon as possible so we catch -d and other
35 # options that will modify our behaviour.
36 # Commands are handled at the end of this script.
37 while getopts "c:dv" flag; do
38 if [ "$1" = '-d' ] || [ "$1" = '--debug' ]; then
42 elif [ "$1" = '-v' ];then
45 elif [ "$1" = '-c' ];then
46 VCSH_OPTION_CONFIG=$OPTARG
52 # Source file even if it's in $PWD and does not have any slashes in it
60 # Read configuration and set defaults if anything's not set
61 [ -n "$VCSH_DEBUG" ] && set -vx
62 [ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
64 # Read configuration files if there are any
65 [ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
66 [ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
67 if [ -n "$VCSH_OPTION_CONFIG" ]; then
68 # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
69 if [ -r "$VCSH_OPTION_CONFIG" ]; then
70 source_all "$VCSH_OPTION_CONFIG"
72 fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
75 [ -n "$VCSH_DEBUG" ] && set -vx
78 [ -z "$VCSH_REPO_D" ] && VCSH_REPO_D="$XDG_CONFIG_HOME/vcsh/repo.d"
79 [ -z "$VCSH_HOOK_D" ] && VCSH_HOOK_D="$XDG_CONFIG_HOME/vcsh/hooks-enabled"
80 [ -z "$VCSH_BASE" ] && VCSH_BASE="$HOME"
81 [ -z "$VCSH_GITIGNORE" ] && VCSH_GITIGNORE='exact'
85 echo "usage: $SELF <options> <command>
90 -v Enable verbose mode
94 [<repo>] Clone from an existing repository
95 delete <repo> Delete an existing repository
96 enter <repo> Enter repository; spawn new instance of \$SHELL
97 help Display this help text
98 init <repo> Initialize a new repository
99 list List all repositories
100 list-tracked List all files tracked by vcsh
102 <repo> List files tracked by a repository
104 <newname> Rename repository
106 <command> Use this repository
107 upgrade <repo> Upgrade repository to currently recommended settings
108 version Print version information
109 which <substring> Find substring in name of any tracked file
111 <repo> Write .gitignore.d/<repo> via git ls-files
113 <repo> <git command> Shortcut to run git commands directly
114 <repo> Shortcut to enter repository" >&2
118 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
122 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
126 echo "$SELF: error: $1" >&2
130 echo "$SELF: info: $1"
136 git remote add origin "$GIT_REMOTE"
137 git config branch.master.remote origin
138 git config branch.master.merge refs/heads/master
139 if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
140 info "remote is empty, not merging anything"
144 for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
146 error "'$object' exists." &&
149 [ "$VCSH_CONFLICT" = '1' ] &&
150 fatal "will stop after fetching and not try to merge!
151 Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
152 git merge origin/master
157 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
159 info "This operation WILL DESTROY DATA!"
160 files=$(git ls-files)
161 echo "These files will be deleted:
165 AGAIN, THIS WILL DELETE YOUR DATA!
166 To continue, type 'Yes, do as I say'"
168 [ "x$answer" = 'xYes, do as I say' ] || exit 16
169 for file in $files; do
170 rm -f $file || info "could not delete '$file', continuing with deletion"
172 rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
183 [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
187 for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
188 [ -x "$hook" ] || continue
189 verbose "executing '$hook'"
195 [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
196 export GIT_WORK_TREE="$VCSH_BASE"
197 mkdir -p "$GIT_WORK_TREE" || fatal "could not create '$GIT_WORK_TREE'" 50
198 cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
204 for repo in "$VCSH_REPO_D"/*.git; do
205 [ -d "$repo" ] && [ -r "$repo" ] && echo $(basename "$repo" .git)
210 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
215 for VCSH_REPO_NAME in $(list); do
222 git ls-files | sort -u
227 [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
228 mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
242 git config core.worktree "$GIT_WORK_TREE"
243 git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
244 git config vcsh.vcsh 'true'
245 [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
251 export GIT_WORK_TREE="$(git config --get core.worktree)"
252 export VCSH_DIRECTORY="$VCSH_REPO_NAME"
256 for VCSH_REPO_NAME in $(list); do
257 for VCSH_FILE in $(get_files); do
258 echo $VCSH_FILE | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
265 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
266 gitignores=$(for file in $(git ls-files); do
268 echo $file; new="${file%/*}"
269 [ "$file" = "$new" ] && break
273 tempfile=$(mktemp) || fatal "could not create tempfile" 51
274 echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
275 for gitignore in $gitignores; do
276 echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
277 if [ x$VCSH_GITIGNORE = x'recursive' ] && [ -d "$gitignore" ]; then
278 { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
281 if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
282 rm -f "$tempfile" || error "could not delete '$tempfile'"
285 if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
286 info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
287 mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
288 fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
290 mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
291 fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
294 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
295 fatal "'\$VCSH_GITIGNORE' must be either 'exact' or 'recursive'" 1
298 if [ "$1" = 'clone' ]; then
299 [ -z "$2" ] && fatal "$1: please specify a remote" 1
300 export VCSH_COMMAND="$1"
302 [ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
303 export VCSH_REPO_NAME
304 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
305 elif [ "$1" = 'version' ]; then
306 echo "$SELF $VERSION"
308 elif [ "$1" = 'which' ]; then
309 [ -z "$2" ] && fatal "$1: please specify a filename" 1
310 [ -n "$3" ] && fatal "$1: too many parameters" 1
311 export VCSH_COMMAND="$1"
312 export VCSH_COMMAND_PARAMETER="$2"
313 elif [ "$1" = 'delete' ] ||
314 [ "$1" = 'enter' ] ||
316 [ "$1" = 'list-tracked-by' ] ||
317 [ "$1" = 'rename' ] ||
319 [ "$1" = 'upgrade' ] ||
320 [ "$1" = 'write-gitignore' ]; then
321 [ -z $2 ] && fatal "$1: please specify repository to work on" 1
322 [ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
323 [ "$1" = 'run' -a -z "$3" ] && fatal "$1: please specify a command" 1
324 export VCSH_COMMAND="$1"
325 export VCSH_REPO_NAME="$2"
326 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
327 [ "$VCSH_COMMAND" = 'rename' ] && export GIT_DIR_NEW="$VCSH_REPO_D/$3.git"
328 [ "$VCSH_COMMAND" = 'run' ] && shift 2
329 [ "$VCSH_COMMAND" = 'write-gitignore' ]
330 elif [ "$1" = 'list' ] ||
331 [ "$1" = 'list-tracked' ]; then
332 export VCSH_COMMAND="$1"
333 elif [ -n "$2" ]; then
334 export VCSH_COMMAND='run'
335 export VCSH_REPO_NAME="$1"
336 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
337 [ -d $GIT_DIR ] || { help; exit 1; }
340 elif [ -n "$1" ]; then
341 export VCSH_COMMAND='enter'
342 export VCSH_REPO_NAME="$1"
343 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
344 [ -d $GIT_DIR ] || { help; exit 1; }
346 # $1 is empty, or 'help'
350 # Did we receive a directory instead of a name?
351 # Mangle the input to fit normal operation.
352 if echo $VCSH_REPO_NAME | grep -q '/'; then
353 export GIT_DIR=$VCSH_REPO_NAME
354 export VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git)
358 for check_directory in "$VCSH_REPO_D" "$VCSH_BASE/.gitignore.d"
360 if [ ! -d "$check_directory" ]; then
361 if [ -e "$check_directory" ]; then
362 fatal "'$check_directory' exists but is not a directory" 13
364 info "attempting to create '$check_directory'"
365 mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
370 verbose "$VCSH_COMMAND begin"
371 export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
375 verbose "$VCSH_COMMAND end, exiting"